AbsorbTracker = LibStub("AceAddon-3.0"):NewAddon("AbsorbTracker", "AceConsole-3.0", "AceEvent-3.0")
AbsorbTrackerGUI = LibStub("AceGUI-3.0")
local media = LibStub("LibSharedMedia-3.0")
local db
local valgbtl = 0
local destgbtl
local amountval = 0
local playername = UnitName("player")
local spellIds = {
[17] = true, 	-- Power Word: Shield
[47753] = true, -- Divine Aegis
[86273] = true, -- Illuminated Healing
[77535] = true, -- Blood Shield
[96263] = true, -- Sacred Shield
[88063] = true, -- Guarded by the Light
[11426] = true, -- Ice barrier
}

local defaults = {
	profile = {
		font = "Friz Quadrata TT",
		fontscale = 12,
		texture = "Blizzard",
		xpos = 0,
		ypos = 0,
		tankmode = false,
		combatcheck = false,
		anicheck = false,
		zerocheck = false,
		labelinput = "",
		inxpos = 100,
		inypos = 0,
		induration = 1,
		insmooth = "OUT",
		inposypos = 0,
		inposxpos = 0,
		outxpos = 100,
		outypos = 0,
		outduration = 1,
		outsmooth = "OUT",
		outposypos = 0,
		outposxpos = 0,
	},
}

local options = {
	type = "group",
	childGroups = "tab",
	args = {
		settings = {
		type = "group",
		name = "Text Settings",
		args = {
				fontsettingsdesc = {
					order = 1,
					type = "description",
					name = "Font settings\n",
					cmdHidden = true
				},
				font = {
					order = 2,
					type = "select",
					name = "Font",
					desc = "Set the font.",
					values = media:HashTable("font"),
					dialogControl = "LSM30_Font",
					get = function(info) return db.font end,
					set = function(info, f) 
					db.font = f
					AbsorbTracker:frame()
					end,
				},
				fontscale = {
					order = 3,
					name = "Font Scale",
					desc = "Set the font scale",
					type = 'range',
					min = 1,
					max = 50,
					step = 1,
					get = function(info) return db.fontscale end,
					set = function(info, fontsc) 
					db.fontscale = fontsc
					AbsorbTracker:frame()
					end,
				},
				outline = {
					order = 4,
					name = "Outline",
					desc = "Outline",
					type = 'select',
					values = {["OUTLINE"]="Outline",["THICKOUTLINE"]="Thickoutline",["MONOCHROME"]="Monochrome",["MONOCHROME,OUTLINE"]="Monochrome + Outline",["MONOCHROME,THICKOUTLINE"]="Monochrome + Thickoutline",["NONE"]="None"},
					get = function(info) return db.outline end,
					set = function(info, line)
					db.outline = line
					AbsorbTracker:frame()
					end,
				},
				header3 = {
					type = 'header',
					order = 5,
					name = "",
				},
				posdesc = {
					order = 6,
					type = "description",
					name = "Position \n",
					cmdHidden = true
				},
				nudgeleft = {
					order = 7,
					name = "Left",
					desc = "Nudge left once",
					type = 'execute',
					get = function(info) return db.xpos end,
					func = function() 
					db.xpos = db.xpos - 1
					AbsorbTracker:frame()
					end,
				},
				xpos = {
					order = 8,
					name = "X",
					desc = "Change horizontal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.xpos end,
					set = function(info, x) 
					db.xpos = x
					AbsorbTracker:frame()
					end,
				},
				nudgeright = {
					order = 9,
					name = "Right",
					desc = "Nudge right once",
					type = 'execute',
					get = function(info) return db.xpos end,
					func = function() 
					db.xpos = db.xpos + 1
					AbsorbTracker:frame()
					end,
				},
				nudgeup = {
					order = 10,
					name = "Up",
					desc = "Nudge up once",
					type = 'execute',
					get = function(info) return db.ypos end,
					func = function() 
					db.ypos = db.ypos + 1
					AbsorbTracker:frame()
					end,
				},
				ypos = {
					order = 11,
					name = "Y",
					desc = "Change veritcal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.ypos end,
					set = function(info, y) 
					db.ypos = y
					AbsorbTracker:frame()
					end,
				},
				nudgedown = {
					order = 12,
					name = "Down",
					desc = "Nudge down once",
					type = 'execute',
					get = function(info) return db.ypos end,
					func = function() 
					db.ypos = db.ypos - 1
					AbsorbTracker:frame()
					end,
				},
				labelinput = {
					order = 13,
					name = "Add text",
					desc = "Add text if you like.",
					type = 'input',
					get = function(info) return db.labelinput end,
					set = function(info, line)
					db.labelinput = line
					AbsorbTracker:runtarget()
				end,
				},
			},
		},
		extras = {
		type = "group",
		name = "Extras",
			args = {
				tankmode = {
					order = 1,
					name = "Enable tank mode",
					desc = "WARNING! The addon will only track absorbs on your self! This is intended for tanks to use.",
					type = 'toggle',
					get = function(info) return db.tankmode end,
					set = function(info, x) 
					db.tankmode = x
					AbsorbTracker:frame()
					if db.tankmode == true then
						AbsorbTracker:Print("Tank mode enabled.")
					end
					if db.tankmode == false then
						AbsorbTracker:Print("Tank mode disabled.")
					end
					end,
				},
				posdesc = {
					order = 2,
					type = "description",
					name = "This will make the addon only track absorbs on yourself!\n",
					cmdHidden = true
				},
				header2 = {
					type = 'header',
					order = 3,
					name = "",
				},
				onlycombat = {
					order = 4,
					name = "Enable only in combat",
					desc = "Shows only the frame during combat",
					type = 'toggle',
					get = function(info) return db.combatcheck end,
					set = function(info, x) 
					db.combatcheck = x
					AbsorbTracker:frame()
					end,
				},
				combatdesc = {
					order = 5,
					type = "description",
					name = "Make the addon only show the frame during combat.\n",
					cmdHidden = true
				},	
				header1 = {
					type = 'header',
					order = 6,
					name = "",
				},
				animation = {
					order = 7,
					name = "Enable animations",
					desc = "Enable to show animations.",
					type = 'toggle',
					get = function(info) return db.anicheck end,
					set = function(info, x) 
					db.anicheck = x
					end,
				},
				anidesc = {
					order = 8,
					type = "description",
					name = "Enables the animation. If disabled you can still change animation settings.",
					cmdHidden = true
				},
				header5 = {
					type = 'header',
					order = 9,
					name = "",
				},
				zerochecker = {
					order = 10,
					name = "Hide if text is '0'",
					desc = "Hides the frame if it's on 0.",
					type = 'toggle',
					get = function(info) return db.zerocheck end,
					set = function(info, x) 
					db.zerocheck = x
					AbsorbTracker:runtarget()
					end,
				},
			},
		},
		inanimationsettings = {
		type = "group",
		name = "IN animation Settings",
			args = {
				indesc = {
					order = 1,
					type = "description",
					name = "Destination where the in animation ends.",
					cmdHidden = true
				},
				innudgeleft = {
					order = 2,
					name = "Left",
					desc = "Nudge left once",
					type = 'execute',
					get = function(info) return db.inxpos end,
					func = function() 
					db.inxpos = db.inxpos - 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inxpos = {
					order = 3,
					name = "X",
					desc = "Change horizontal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.inxpos end,
					set = function(info, x) 
					db.inxpos = x
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				innudgeright = {
					order = 4,
					name = "Right",
					desc = "Nudge right once",
					type = 'execute',
					get = function(info) return db.inxpos end,
					func = function() 
					db.inxpos = db.inxpos + 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				innudgeup = {
					order = 5,
					name = "Up",
					desc = "Nudge up once",
					type = 'execute',
					get = function(info) return db.inypos end,
					func = function() 
					db.inypos = db.inypos + 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inypos = {
					order = 6,
					name = "Y",
					desc = "Change veritcal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.inypos end,
					set = function(info, y) 
					db.inypos = y
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				innudgedown = {
					order = 7,
					name = "Down",
					desc = "Nudge down once",
					type = 'execute',
					get = function(info) return db.inypos end,
					func = function() 
					db.inypos = db.inypos - 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				header4 = {
					type = 'header',
					order = 8,
					name = "",
				},
				inposdesc = {
					order = 9,
					type = "description",
					name = "Start position, where the in animation starts.",
					cmdHidden = true
				},
				inposnudgeleft = {
					order = 10,
					name = "Left",
					desc = "Nudge left once",
					type = 'execute',
					get = function(info) return db.inposxpos end,
					func = function() 
					db.inposxpos = db.inposxpos - 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inposxpos = {
					order = 11,
					name = "X",
					desc = "Change horizontal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.inposxpos end,
					set = function(info, x) 
					db.inposxpos = x
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inposnudgeright = {
					order = 12,
					name = "Right",
					desc = "Nudge right once",
					type = 'execute',
					get = function(info) return db.inposxpos end,
					func = function() 
					db.inposxpos = db.inposxpos + 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inposnudgeup = {
					order = 13,
					name = "Up",
					desc = "Nudge up once",
					type = 'execute',
					get = function(info) return db.inposypos end,
					func = function() 
					db.inposypos = db.inposypos + 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inposypos = {
					order = 14,
					name = "Y",
					desc = "Change veritcal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.inposypos end,
					set = function(info, y) 
					db.inposypos = y
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				inposnudgedown = {
					order = 15,
					name = "Down",
					desc = "Nudge down once",
					type = 'execute',
					get = function(info) return db.inposypos end,
					func = function() 
					db.inposypos = db.inposypos - 1
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				header7 = {
					type = 'header',
					order = 16,
					name = "",
				},
				induration = {
					order = 17,
					name = "Speed",
					desc = "Change the speed",
					type = 'range',
					min = 1,
					max = 20,
					step = 1,
					get = function(info) return db.induration end,
					set = function(info, i) 
					db.induration = i
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
				insmoothtype = {
					order = 18,
					name = "In smooth type",
					desc = "Change the smooth type.",
					type = 'select',
					values = {["IN"]="IN",["IN_OUT"]="IN_OUT",["NONE"]="NONE",["OUT"]="OUT",},
					get = function(info) return db.insmooth end,
					set = function(info, line) 
					db.insmooth = line
					amountval = ("+9001")
					AbsorbTracker:ins()
					end,
				},
			},
		},
		outanimationsettings = {
		type = "group",
		name = "OUT animation Settings",
			args = {
				outdesc = {
					order = 1,
					type = "description",
					name = "Destination where the in animation ends.",
					cmdHidden = true
				},
				outnudgeleft = {
					order = 2,
					name = "Left",
					desc = "Nudge left once",
					type = 'execute',
					get = function(info) return db.outxpos end,
					func = function() 
					db.outxpos = db.outxpos - 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outxpos = {
					order = 3,
					name = "X",
					desc = "Change horizontal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.outxpos end,
					set = function(info, x) 
					db.outxpos = x
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outnudgeright = {
					order = 4,
					name = "Right",
					desc = "Nudge right once",
					type = 'execute',
					get = function(info) return db.outxpos end,
					func = function() 
					db.outxpos = db.outxpos + 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outnudgeup = {
					order = 5,
					name = "Up",
					desc = "Nudge up once",
					type = 'execute',
					get = function(info) return db.outypos end,
					func = function() 
					db.outypos = db.outypos + 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outypos = {
					order = 6,
					name = "Y",
					desc = "Change veritcal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.outypos end,
					set = function(info, y) 
					db.outypos = y
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outnudgedown = {
					order = 7,
					name = "Down",
					desc = "Nudge down once",
					type = 'execute',
					get = function(info) return db.outypos end,
					func = function() 
					db.outypos = db.outypos - 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				header11 = {
					type = 'header',
					order = 8,
					name = "",
				},
				outposdesc = {
					order = 9,
					type = "description",
					name = "Start position, where the in animation starts.",
					cmdHidden = true
				},
				outposnudgeleft = {
					order = 10,
					name = "Left",
					desc = "Nudge left once",
					type = 'execute',
					get = function(info) return db.outposxpos end,
					func = function() 
					db.outposxpos = db.outposxpos - 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outposxpos = {
					order = 11,
					name = "X",
					desc = "Change horizontal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.outposxpos end,
					set = function(info, x) 
					db.outposxpos = x
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outposnudgeright = {
					order = 12,
					name = "Right",
					desc = "Nudge right once",
					type = 'execute',
					get = function(info) return db.outposxpos end,
					func = function() 
					db.outposxpos = db.outposxpos + 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outposnudgeup = {
					order = 13,
					name = "Up",
					desc = "Nudge up once",
					type = 'execute',
					get = function(info) return db.outposypos end,
					func = function() 
					db.outposypos = db.outposypos + 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outposypos = {
					order = 14,
					name = "Y",
					desc = "Change veritcal position",
					type = 'range',
					min = -1500,
					max = 1500,
					step = 1,
					get = function(info) return db.outposypos end,
					set = function(info, y) 
					db.outposypos = y
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outposnudgedown = {
					order = 15,
					name = "Down",
					desc = "Nudge down once",
					type = 'execute',
					get = function(info) return db.outposypos end,
					func = function() 
					db.outposypos = db.outposypos - 1
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				header10 = {
					type = 'header',
					order = 16,
					name = "",
				},
				outduration = {
					order = 17,
					name = "Speed",
					desc = "Change the speed",
					type = 'range',
					min = 1,
					max = 20,
					step = 1,
					get = function(info) return db.outduration end,
					set = function(info, i) 
					db.outduration = i
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
				outsmoothtype = {
					order = 18,
					name = "Out smooth type",
					desc = "Change the smooth type.",
					type = 'select',
					values = {["IN"]="IN",["IN_OUT"]="IN_OUT",["NONE"]="NONE",["OUT"]="OUT",},
					get = function(info) return db.outsmooth end,
					set = function(info, line) 
					db.outsmooth = line
					amountval = ("+9001")
					AbsorbTracker:outs()
					end,
				},
			},	
		},
	},
}

function AbsorbTracker:OnInitialize()
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AbsorbTracker", "AbsorbTracker")
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AbsorbTracker", options, {"AbsorbTracker", "at"})
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("AbsorbTracker", options)
	
	self.db = LibStub("AceDB-3.0"):New("AbsorbTrackerDB", defaults)
	db = self.db.profile
	
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	self:RegisterChatCommand("at", "ChatCommand")
	self:RegisterChatCommand("AbsorbTracker", "ChatCommand")
	
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	
	frame1 = CreateFrame("MessageFrame","frame1",UIParent)
	text = frame1:CreateFontString("test")
	
	CreateFrame( "GameTooltip", "text2", nil, "GameTooltipTemplate" )
	text2:SetOwner( WorldFrame, "ANCHOR_NONE" )
	text2:AddFontStrings(
	text2:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
	text2:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ) )
	
	AbsorbTracker:frame()
end
	
function AbsorbTracker:OnEnable()
	self:Print("Ingela's Absorb Tracker loaded. To configurate: /AbsorbTracker or /at. Enjoy!")
	
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_TARGET")
	self:RegisterEvent("SPELL_AURA_REFRESH")
	self:RegisterEvent("SPELL_AURA_REMOVED")
	self:RegisterEvent("SPELL_AURA_APPLIED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	
	if not media:Fetch("statusbar", db.texture, true) then db.texture = "Blizzard" end
	if not media:Fetch("font", db.font, true) then db.font = "Friz Quadrata TT" end
end

function AbsorbTracker:RefreshConfig()
	db = self.db.profile
	AbsorbTracker:frame()
end

function AbsorbTracker:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(AbsorbTracker, "at", "AbsorbTracker", input)
	end
end

function AbsorbTracker:frame()
	frame1:SetWidth(300)
	frame1:SetHeight(150)
	frame1:SetFont(media:Fetch("font", db.font), db.fontscale, db.outline~="NONE" and db.outline or nil)
	frame1:SetPoint("CENTER", UIParent, "CENTER", db.xpos, db.ypos)
	frame1:Show()
	
	text:SetFont(media:Fetch("font", db.font), db.fontscale, db.outline~="NONE" and db.outline or nil)
	text:SetPoint("CENTER", UIParent, "CENTER", db.xpos, db.ypos)
	text:SetSize(300, 150)
	text:Show()
	
	if db.combatcheck == true then frame1:Hide() text:Hide() end
	if db.combatcheck == false then frame1:Show() text:Show() end
end

local groups = {};
local function GetFrame()
	local g = table.remove(groups);
	if not g then
		g = CreateFrame("Frame");
		g.text = g:CreateFontString();
		g.group = g.text:CreateAnimationGroup();
		g.anim = g.group:CreateAnimation("Translation");		
	end
	return g;
end

local function ReleaseFrame(f)
	table.insert(groups, f);
end

function AbsorbTracker:ins()
	local uiscale = UIParent:GetEffectiveScale()
	local frame = GetFrame();
	frame.group:SetLooping("NONE")
	    
	frame:SetWidth(300)
	frame:SetHeight(150)
	frame:SetPoint("CENTER", UIParent, "CENTER", db.inposxpos, db.inposypos)
	frame:SetScale(uiscale)
	
	frame.text:SetFont(media:Fetch("font", db.font), db.fontscale, db.outline~="NONE" and db.outline or nil)
	frame.text:SetPoint("CENTER", UIParent, "CENTER", db.inposxpos, db.inposypos)
	frame.text:SetSize(300, 150)
	frame.text:Show()
	frame.text:SetText(amountval)
	
	frame.anim:SetDuration(db.induration)
	frame.anim:SetSmoothing(db.insmooth)
	frame.anim:SetOffset(db.inxpos, db.inypos)
	
	frame.group:Play()
	
	frame.anim:SetScript("OnFinished", function(self, requested)
		frame.text:Hide()
		ReleaseFrame(frame);
	end)
end

function AbsorbTracker:outs()
	local uiscale = UIParent:GetEffectiveScale()
	local frame = GetFrame();
	frame.group:SetLooping("NONE")
	    
	frame:SetWidth(300)
	frame:SetHeight(150)
	frame:SetPoint("CENTER", UIParent, "CENTER", db.outposxpos, db.outposypos)
	frame:SetScale(uiscale)
	
	frame.text:SetFont(media:Fetch("font", db.font), db.fontscale, db.outline~="NONE" and db.outline or nil)
	frame.text:SetPoint("CENTER", UIParent, "CENTER", db.outposxpos, db.outposypos)
	frame.text:SetSize(300, 150)
	frame.text:Show()
	frame.text:SetText(amountval)
	
	frame.anim:SetDuration(db.outduration)
	frame.anim:SetSmoothing(db.outsmooth)
	frame.anim:SetOffset(db.outxpos, db.outypos)
	
	frame.group:Play()
	
	frame.anim:SetScript("OnFinished", function(self, requested)
		frame.text:Hide()
		ReleaseFrame(frame);
	end)
end

function AbsorbTracker:PLAYER_REGEN_DISABLED()
	if db.combatcheck == true then frame1:Show() text:Show() end
end

function AbsorbTracker:PLAYER_REGEN_ENABLED()
	if db.combatcheck == true then frame1:Hide() text:Hide() end
end

function AbsorbTracker:SPELL_AURA_APPLIED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	if spellIds[spellId] then
		if spellId == 88063 then namegbtl = sourceName valgbtl = amount else valgbtl = 0 end
		AbsorbTracker:runtarget()
		if db.anicheck == true then
			if amount ~= 0 or amount ~= nil then
				amountval = ("+" .. amount)
				AbsorbTracker:ins()
			end
		end
	end
end

function AbsorbTracker:SPELL_AURA_REMOVED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	if spellIds[spellId] then
		if spellId == 88063 then namegbtl = sourceName valgbtl = 0 else valgbtl = 0 end
		AbsorbTracker:runtarget()
		if db.anicheck == true then
			if amount ~= 0 or amount ~=nil then
				amountval = ("-" .. amount)
				AbsorbTracker:outs()
			end
		end
	end
end

function AbsorbTracker:SPELL_AURA_REFRESH(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	if spellIds[spellId] then
		if spellId == 88063 then namegbtl = sourceName valgbtl = amount else valgbtl = 0 end
		AbsorbTracker:runtarget()
	end
end

function AbsorbTracker:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
    if destGUID ~= UnitGUID(db.tankmode and 'player' or 'target') then return end
    local func = self[event]
    if (func) then
        func(self, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
    end
end

function AbsorbTracker:UNIT_TARGET(_, arg1, ...)
	if arg1 == "player" then
		AbsorbTracker:runtarget()
	end
end

function AbsorbTracker:runtarget()
	sum = 0
		if db.tankmode == false then 
			if UnitIsPlayer("target") and UnitIsFriend("target", "player") and not UnitIsDeadOrGhost("target") then 
				text:Show()
				frame1:Show()
				 
			else
				text:Hide() 
				frame1:Hide()
			end
		end
		if db.tankmode == true then
			frame1:Show()
			text:Show()
		end
		if db.combatcheck == true then
			local inLockdown = InCombatLockdown()
				if inLockdown == 1 then frame1:Show() text:Show() end
				if inLockdown == nil then frame1:Hide() text:Hide() end
		end

		for t = 1,40 do
			if db.tankmode == false then
				a,b,c,d,e,f,g,h,i,j,k = UnitBuff("target", t)
			elseif db.tankmode == true then
				a,b,c,d,e,f,g,h,i,j,k = UnitBuff("player", t)
			end
				if spellIds[k] then
					if k == 88063 then
						if db.tankmode == false then
							local playertarget = UnitName("target")
								if h == "player" and playertarget == playername then sum = sum + valgbtl end
								if h == "target" and playertarget == namegbtl then sum = sum + valgbtl end
						end
						if db.tankmode == true then
								if h == "player" and namegbtl == playername then sum = sum + valgbtl end
						end
					else
						text2:ClearLines()
							if db.tankmode == false then
								text2:SetUnitBuff("target", t)
							end
							if db.tankmode == true then
								text2:SetUnitBuff("player", t)
							end
						local txt = text2TextLeft2:GetText()
						local _, val, _ = strsplit(" ", txt)
						sum = sum + val
					end
				end
		end	
	text:SetText(db.labelinput .. sum)
	if db.zerocheck == true then
		local zerotest = text:GetText()
			if zerotest == "0" or zerotest == nil then
				text:Hide()
			end 
			if tonumber(zerotest) > 0 then
				text:Show()
			end
	end
end